/*
                                                                     
  B i n k C o l               (c) Copyright 1996,1997 Peter Karlsson 
 ı
  A colour configuration program for use with BinkleyTerm version    
  2.60 or 2.60XE (r1-r4, r5)                                         
                                                                     
  C o m m a n d   l i n e   f o r m a t                              
 ı
  BINKCOL [drive:][path]filename                                     
  BINKCOL [brdr set tday pndg actvty trnsfr rev popwin [btext wbrdr  
          [mdmsent mdmrecv]]                                         
  BINKCOL [/XE1|/XE5]                                                
                                                                     
    [drive:][path]filename   Path and name to Binkley.Cfg, auto      
                             detects XE mode                         
    brdr set tday pndg...    Colours as given in Binkley.Cfg         
    /XE1                     Use XE r1-r4 version standard colours   
    /XE5                     Use XE r5 version standard colours      
                                                                     
  U s a g e                                                          
 ı
  This program is simple to use, just use the arrow keys to change   
  the colours, up and down for the background and left and right for 
  the foreground. Use Page Up and Page Down to select the colour to  
  change.                                                            
                                                                     
  When you're done, press ESC and you will be shown the colour       
  settings. You will be offered to save it to a file which can then  
  be included in the main BinkleyTerm configuration via the Include  
  statement.                                                         
                                                                     
  V e r s i o n   h i s t o r y                                      
 ı
   v 1.00 - 1996-07-01 -                                             
   v 1.01 - 1996-07-02 - Added configuration of the 2.60XE version   
                         (I just downloaded it and found out that it 
                         completely broke my old colour config)      
                       - Shows screen attributes in hex mode also    
   v 1.02 - 1997-06-20 - Cosmetic change for the XE-R4 screen capture
                       - Supports XE-R5 new screen layout            
   v 1.03 - 1997-07-07 - Small fix for the XE-R5 screen capture      
                       - Can be compiled with EMX (GNU C++ for OS/2) 
                                                                     
  A d d r e s s e s   t o   t h e   a u t h o r                      
 ı
  Regular mail:              Electronic mail:                        
  Peter Karlsson             Internet: pk@abc.se                     
  Vrnsta, Ullerster        Fidonet   2:206/221.0                   
  S-718 92  FRVI            Fax:      +46-(0)581-32110              
  SWEDEN                                                             
                             Web: http://nafmo.home.ml.org/          
                                                                     
  C o m p i l e r s                                                  
 ı
  This program was compiled using Borland Turbo C++ 1.0 under DOS,   
  and EMX GNU C++ 0.9c for OS/2.                                     
                                                                     
  S t a t u s   o f   t h e   p r o g r a m                          
 ı
  This program is freeware. This means that you have all rights to   
  freely distribute and use the program. The author will though      
  retain all rights to the program. It may not be modified in any    
  way. See above for address. When you distribute this program, make 
  sure that all files described below are included.                  
                                                                     
  You may change the programs to suit your own needs, but you do not 
  have the rights to distribute such a changed file. If you think    
  that your change is useful, please send a file describing your     
  changes to me, at the address above. The best way if you could     
  use the DOS command FC to make a file containing the changes:      
                                                                     
     FC old_file_name new_file_name > BINKCOL.DIF                    
                                                                     
  Then send me BINKCOL.DIF, as a print-out, a netmail message or a   
  netmail file-attach. Please include your name and address(es).     
                                                                     
  Everyone who contributes will be mentioned here!                   
                                                                     
  D i s c l a i m e r   O f   W a r r a n t y                        
 ı
  THIS PROGRAM IS DISTRIBUTED AS-IS. THE PROGRAMMER GIVES NO         
  WARRANTY, NOR EXPRESS OR IMPLIED, AS TO THE FUNCTION OF THIS       
  PROGRAM. IN NO EVENT SHALL THE PROGRAMMER BE LIABLE FOR ANY DAMAGE 
  WHATSOEVER (INCLUDING, WITHOUT LIMITATION, DAMAGES FOR LOSS OF     
  BUSINESS PROFITS, BUSINESS INTERRUPTION, LOSS OF BUSINESS          
  INFORMATION, OR OTHER PECUNIARY LOSS) ARISING OUT OF THE USE, OR   
  INABILITY TO USE, THIS PROGRAM, EVEN IF THE PROGRAMMER HAS BEEN    
  ADVISED OF THE POSSIBILITY OF SUCH DAMAGES. WHEN USING THE PROGRAM 
  YOU AUTOMATICALLY ACCEPT THESE TERMS.                              
                                                                     
  I n c l u d e d   f i l e s                                        
 ı
    BINKCOL.C     This source code / documentation file              
    BINKCOL.DEF   OS/2 definitions file                              
    BINKCOL.EXE   The executable program, DOS version                
    BINKCOLP.EXE  The executable program, OS2/DOS386 version (EMX)   
    FILE_ID.DIZ   Description file for BBS:es                        
    WOLVES.COM    Softwolves program catalogue                       
                                                                     
  FREEWARE */

/* Includes and defines */

#if !defined(__EMX__) && !defined(__TURBOC__)
#error Supported compilers: Turbo C++ and EMX
#endif

#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#ifdef __EMX__
#include <sys/video.h>
#endif

#define TEXTAREAS 8
#define XETEXTAREAS 10
#define XE5TEXTAREAS 12
#define VERSION "1.03"

/* Video command compatibility */

#ifdef __TURBOC__
#define CLRSCR()                clrscr()
#define GOTOXY(x,y)             gotoxy(x,y)
#define PUTS(str)               cputs(str)
#define PRINTF                  cprintf
#define ATTRIBUTES(a)           textattr(a)
#define GETS(str)               cgets(str)
#define CR                      "\n\r"
#endif
#ifdef __EMX__
#define CLRSCR()                { v_clear(); v_gotoxy(0,0); }
#define GOTOXY(x,y)             v_gotoxy(x-1,y-1)
#define PUTS(str)               v_puts(str)
#define PRINTF                  v_printf
#define ATTRIBUTES(a)           v_attrib(a)
#define GETS(str)               gets(str)
#define CR                      "\n"
#endif

/* Type definitions */

enum colour_t { plain, xr1, xr5 };

typedef struct binkcolour_s {
    unsigned int    brdr, set, tday, pndg, actvty, trnsfr, rev, popwin,
                    brdrtext, winborder, modemsent, modemrecv;
    enum colour_t   xeflag;
} Binkcolour;

/* Function prototypes */

void paintscreen(const Binkcolour *);
void colourconfiguration(Binkcolour *);

/* main */

int main(int argc, char *argv[])
{
    Binkcolour  colours = { 112, 9, 10, 11, 14, 12, 48, 7, 7, 7, 7, 7, plain };
    char        ch;
#ifdef __EMX__
    int         normvideo;
#endif

#ifdef __EMX__
    v_init();
    normvideo = v_getattr();
#endif

    /* One parameter options:
     * ? anywhere gives the help screen
     * /XE1 loads up the BinkleyTerm 2.60XE-R1 default colours
     * /XE5 loads up the BinkleyTerm 2.60XE-R5 default colours
     * filename loads the colour configuration from that files (autodetecting
     * XE mode)
     */

    if (2 == argc) {
        if (strchr(argv[1], '?')) { /* Help screen */
            PUTS("Colour configuration program for BinkleyTerm 2.60, version " VERSION CR);
            PUTS("(c) Copyright 1996,1997 Peter Karlsson - pk@abc.se" CR CR);
            PUTS("  BINKCOL [brdr set tday pndg actvty trnsfr rev popwin [btext wbrdr" CR);
            PUTS("           [msent mrecv]]]" CR);
            PUTS("  BINKCOL [[drive:][path]binkley.cfg|/XE1|/XE5]" CR CR);
            PUTS("brdr set tday pndg...       Colours as specified in Binkley.Cfg" CR);
            PUTS("[drive:][path]binkley.cfg   File to read configuration from" CR);
            PUTS("/XE1                        Define colours for the XE-R1 version" CR);
            PUTS("/XE5                        Define colours for the XE-R5 version");
            return 0;
        }

        if (!stricmp(argv[1], "/XE1")) /* XE-R1 mode */
            colours.xeflag = xr1;
        else if (!stricmp(argv[1], "/XE5")) /* XE-R5 mode */
            colours.xeflag = xr5;
        else { /* Open configuration file */
            char    keyword[20], buff[100];
            FILE   *binkcfg;

            binkcfg = fopen(argv[1], "rt");

            while (NULL != fgets(buff, 100, binkcfg)) {
                buff[99] = '\0';
                sscanf(buff, "%s", keyword);
                if (!(stricmp(keyword, "Colors"))) {
                    unsigned numpars;
                    numpars = sscanf(buff, "%s %u %u %u %u %u %u %u %u %u %u %u %u",
                                     keyword, &colours.brdr, &colours.set,
                                     &colours.tday, &colours.pndg,
                                     &colours.actvty, &colours.trnsfr,
                                     &colours.rev, &colours.popwin,
                                     &colours.brdrtext, &colours.winborder,
                                     &colours.modemsent, &colours.modemrecv);
                    if (11 == numpars)
                        colours.xeflag = xr1; /* XE-R1 version */
                    else if (13 == numpars)
                        colours.xeflag = xr5; /* XE-R5 version */
                    else
                        colours.xeflag = plain; /* Standard version */
                    break;
                }
            }

            fclose(binkcfg);
        }
    }

    /*
     * Get colours directly from the command line if they were entered that
     * way
     */

    if (9 == argc || 11 == argc || 13 == argc) {
        unsigned int    count, *colour_p = (unsigned int *) &colours;

        for(count = 1; count < argc; count ++) {
            *colour_p = atoi(argv[count]);
            colour_p ++;
        }

        switch (argc) {
        case 9:  colours.xeflag = plain; break;
        case 11: colours.xeflag = xr1;   break;
        case 13: colours.xeflag = xr5;   break;
        }
    }

    /* Do the actual work */

    colourconfiguration(&colours);

    /* Display the settings and ask if we want to save */

#ifdef __TURBOC__
    normvideo();
#endif
#ifdef __EMX__
    v_attrib(normvideo);
#endif
    CLRSCR();
    PUTS("This is the colour configuration statement for your Binkley.Cfg:" CR);
    PRINTF("Colors %u %u %u %u %u %u %u %u",
            colours.brdr, colours.set, colours.tday, colours.pndg,
            colours.actvty, colours.trnsfr, colours.rev, colours.popwin);
    if (plain != colours.xeflag)
        PRINTF(" %u %u", colours.brdrtext, colours.winborder);
    if (xr5 == colours.xeflag)
        PRINTF(" %u %u", colours.modemsent, colours.modemrecv);

    PUTS(CR CR "Do you want to write it to a file [y/N]? ");

    ch = getche();
    if ('y' == ch || 'Y' == ch) {
        char    filename[60];
        FILE   *colourcfg;

        PUTS(CR "This will OVERWRITE the existing file!" CR CR);

        PUTS("Please enter a file name: ");
        filename[0] = 58;
        GETS(filename);
        filename[filename[1] + 2] = '\0';

        colourcfg = fopen(&filename[2], "wt");
        fputs("; Colour configuration created by BinkCol " VERSION "\n",
              colourcfg);
        fprintf(colourcfg, "Colors %u %u %u %u %u %u %u %u",
            colours.brdr, colours.set, colours.tday, colours.pndg,
            colours.actvty, colours.trnsfr, colours.rev, colours.popwin);
        if (plain != colours.xeflag)
            fprintf(colourcfg, " %u %u", colours.brdrtext, colours.winborder);
        if (xr5 == colours.xeflag)
            fprintf(colourcfg, " %u %u", colours.modemsent, colours.modemrecv);
        fputc('\n', colourcfg);
        fclose(colourcfg);
    }

    /* Flush the buffer */

    if ('\0' == ch)
        getch();

    return 0;
}

/*
 * paintscreen
 * Draws the BinkleyTerm screen using the current colour configurations
 */

void paintscreen(const Binkcolour *colour_p) {
    int     count;

    switch (colour_p->xeflag) {
    case plain: /* Normal mode */
        /* Border */

        ATTRIBUTES(colour_p->brdr);
        GOTOXY(1, 1);
        PUTS(" Node: 2:206/221                                 Quinta Essentia - vaghDIch Hap ");

        for(count = 2; count < 24; count ++) {
            GOTOXY(1, count);
            PUTS(" ");
            GOTOXY(80, count);
            PUTS(" ");
        }

        GOTOXY(1, 24);
        PUTS(" BinkleyTerm Colour Configuration Ver. " VERSION "                   Press ESC To Exit ");

        /* Current Settings window */

        ATTRIBUTES(colour_p->set);
        GOTOXY(2, 2);
        PUTS(" Current Settings Ŀ");
        GOTOXY(2, 3);
        PUTS(" Mon Jul 01 @ 14:33 ");
        GOTOXY(2, 4);
        PUTS(" Event:  10/R       ");
        GOTOXY(2, 5);
        PUTS(" Port:   57600  Com4");
        GOTOXY(2, 6);
        PUTS(" Status: Init       ");
        GOTOXY(2, 7);
        PUTS(" M'Task: OS/2    01 ");
        GOTOXY(2, 8);
        PUTS("");

        /* Today at a Glance Window */

        ATTRIBUTES(colour_p->tday);
        GOTOXY(24, 2);
        PUTS(" Today at a Glance Ŀ");
        GOTOXY(24, 3);
        PUTS(" BBS/Mail:  0/31     ");
        GOTOXY(24, 4);
        PUTS(" Calls Out: 0        ");
        GOTOXY(24, 5);
        PUTS(" Good/Cost: 0/0      ");
        GOTOXY(24, 6);
        PUTS(" Files I/O: 0/0      ");
        GOTOXY(24, 7);
        PUTS(" Last: 2:204/145     ");
        GOTOXY(24, 8);
        PUTS("");

        /* Pending Outbound Mail window */

        ATTRIBUTES(colour_p->pndg);
        GOTOXY(47, 2);
        PUTS(" Pending Outbound Mail Ŀ");
        GOTOXY(47, 3);
        PUTS(" Node       Files Size  Status ");
        GOTOXY(47, 4);
        PUTS("");
        GOTOXY(79, 4);
        PUTS("");
        GOTOXY(47, 5);
        PUTS(" 2:201/293      2 4.6K     H - ");
        GOTOXY(47, 6);
        PUTS(" 581:581/1      2 1.7K     N - ");
        GOTOXY(47, 7);
        PUTS("                               ");
        GOTOXY(47, 8);
        PUTS("");

        /* Reverse video
         */

        ATTRIBUTES(colour_p->rev);
        GOTOXY(48, 4);
        PUTS(" 2:206/137      2 296b    CR - ");

        /* Recent Activity window */

        ATTRIBUTES(colour_p->actvty);
        GOTOXY(2, 9);
        PUTS(" Recent Activity Ŀ");
        GOTOXY(2, 10);
        PUTS("                                                                            ");
        GOTOXY(2, 11);
        PUTS("   ");
        GOTOXY(76, 11);
        PUTS("   ");
        GOTOXY(2, 12);
        PUTS("   ");
        GOTOXY(76, 12);
        PUTS("   ");
        GOTOXY(2, 13);
        PUTS("   ");
        GOTOXY(76, 13);
        PUTS("   ");
        GOTOXY(2, 14);
        PUTS("   ");
        GOTOXY(76, 14);
        PUTS("   ");
        GOTOXY(2, 15);
        PUTS("                                                                            ");
        GOTOXY(2, 16);
        PUTS(" + 14:33:29 begin, BinkleyTerm Colour Configuration Ver. " VERSION "               ");
        GOTOXY(2, 17);
        PUTS(" : 14:33:29 Starting Event 10                                               ");
        GOTOXY(2, 18);
        PUTS(" : 14:33:33 Entering COLOUR CONFIGURATION Mode                              ");
        GOTOXY(2, 19);
        PUTS("");

        /* Transfer Status window */

        ATTRIBUTES(colour_p->trnsfr);
        GOTOXY(2, 20);
        PUTS(" Transfer Status Ŀ");
        GOTOXY(2, 21);
        PUTS(" Event 1 starts in 567 minutes                                              ");
        GOTOXY(2, 22);
        PUTS(" Flags for next event: S R                                                  ");
        GOTOXY(2, 23);
        PUTS("");

        /* Pop-Up window */

        ATTRIBUTES(colour_p->popwin);
        GOTOXY(6, 11);
        PUTS(" Poll a Node Ŀ");
        GOTOXY(6, 12);
        PUTS(" Poll:       ________________________________________               ");
        GOTOXY(6, 13);
        PUTS("                                                                    ");
        GOTOXY(6, 14);
        PUTS("");
        break;
    case xr1: /* XE-R1 mode */
        /* Border */

        ATTRIBUTES(colour_p->brdr);
        GOTOXY(1, 1);
        PUTS("[01]  Node: 2:206/221                             Quinta Essentia - vaghDIch Hap");

        GOTOXY(1, 24);
        PUTS("BinkleyTerm Colour Configuration Ver. " VERSION "XE                   Press ESC To Exit");

        /* Current Settings window */

        ATTRIBUTES(colour_p->set);
        GOTOXY(2, 3);
        PUTS("Mon Jul 01 @ 14:33");
        GOTOXY(2, 4);
        PUTS("Event:  10/R      ");
        GOTOXY(2, 5);
        PUTS("Port:   4    57600");
        GOTOXY(2, 6);
        PUTS("Status: Init      ");
        GOTOXY(2, 7);
        PUTS("M'Task: OS/2      ");

        /* Today at a Glance Window */

        ATTRIBUTES(colour_p->tday);
        GOTOXY(22, 3);
        PUTS("BBS/Mail:  0/31    ");
        GOTOXY(22, 4);
        PUTS("Calls Out: 0       ");
        GOTOXY(22, 5);
        PUTS("Good/Cost: 0/0     ");
        GOTOXY(22, 6);
        PUTS("Files I/O: 0/0     ");
        GOTOXY(22, 7);
        PUTS("Last:     2:204/145");

        /* Pending Outbound Mail window */

        ATTRIBUTES(colour_p->pndg);
        GOTOXY(43, 3);
        PUTS("Node            Files Size Age Status");
        GOTOXY(43, 5);
        PUTS("2:201/293           2 4.6K  13 H    -");
        GOTOXY(43, 6);
        PUTS("581:581/1           2 1.7K   8  N   -");
        GOTOXY(43, 7);
        PUTS("                                     ");

        /* Reverse video
         */

        ATTRIBUTES(colour_p->rev);
        GOTOXY(43, 4);
        PUTS("2:206/137           2 296b        RC-");

        /* Recent Activity window */

        ATTRIBUTES(colour_p->actvty);
        GOTOXY(2, 10);
        PUTS("                                                                              ");
        GOTOXY(2, 11);
        PUTS("    ");
        GOTOXY(76, 11);
        PUTS("    ");
        GOTOXY(2, 12);
        PUTS("    ");
        GOTOXY(76, 12);
        PUTS("    ");
        GOTOXY(2, 13);
        PUTS("    ");
        GOTOXY(76, 13);
        PUTS("    ");
        GOTOXY(2, 14);
        PUTS("    ");
        GOTOXY(76, 14);
        PUTS("    ");
        GOTOXY(2, 15);
        PUTS("                                                                              ");
        GOTOXY(2, 16);
        PUTS("+ 14:33:29 begin, BinkleyTerm Colour Configuration Ver. " VERSION "XE                ");
        GOTOXY(2, 17);
        PUTS(": 14:33:29 Starting Event 10                                                  ");
        GOTOXY(2, 18);
        PUTS(": 14:33:33 Entering COLOUR CONFIGURATION Mode                                 ");

        /* Transfer Status window */

        ATTRIBUTES(colour_p->trnsfr);
        GOTOXY(2, 21);
        PUTS(" Event 1 starts in 9h 27min                                                   ");
        GOTOXY(2, 22);
        PUTS(" Flags for next event: S R                                                    ");

        /* Pop-Up window */

        ATTRIBUTES(colour_p->popwin);
        GOTOXY(6, 11);
        PUTS(" Poll a Node Ŀ");
        GOTOXY(6, 12);
        PUTS(" Poll:       ________________________________________               ");
        GOTOXY(6, 13);
        PUTS("                                                                    ");
        GOTOXY(6, 14);
        PUTS("");

        /* Border text */

        ATTRIBUTES(colour_p->brdrtext);
        GOTOXY(2, 2);
        PUTS(" Current Settings ");
        GOTOXY(22, 2);
        PUTS(" Today at a Glance ");
        GOTOXY(43, 2);
        PUTS(" Pending Outbound Mail ");
        GOTOXY(2, 9);
        PUTS(" Recent Activity ");
        GOTOXY(2, 20);
        PUTS(" Transfer Status ");

        /* Window borders */

        ATTRIBUTES(colour_p->winborder);
        GOTOXY(1, 2);
        PUTS("");
        GOTOXY(20, 2);
        PUTS("");
        GOTOXY(41, 2);
        PUTS("");
        GOTOXY(66, 2);
        PUTS("Ŀ");

        for(count = 3; count < 8; count ++) {
            GOTOXY(1, count);
            PUTS("");
            GOTOXY(20, count);
            PUTS("");
            GOTOXY(41, count);
            PUTS("");
            GOTOXY(80, count);
            PUTS("");
            if (count < 5) {
                GOTOXY(1, count + 18);
                PUTS("");
                GOTOXY(80, count + 18);
                PUTS("");
            }
        }

        GOTOXY(1, 8);
        PUTS("");
        GOTOXY(19, 9);
        PUTS("Ŀ");

        for(count = 10; count < 19; count ++) {
            GOTOXY(1, count);
            PUTS("");
            GOTOXY(80, count);
            PUTS("");
        }

        GOTOXY(1, 19);
        PUTS("");
        GOTOXY(19, 20);
        PUTS("Ŀ");
        GOTOXY(1, 23);
        PUTS("");
        break;
    case xr5: /* XE-R5 mode */
        /* Border */

        ATTRIBUTES(colour_p->brdr);
        GOTOXY(1, 1);
        PUTS("-01-  Node: 2:206/221                             Quinta Essentia - vaghDIch Hap");

        GOTOXY(1, 24);
        PUTS("BinkleyTerm Colour Configuration Ver. " VERSION "XE/5                 Press ESC To Exit");

        /* Current Settings window */

        ATTRIBUTES(colour_p->set);
        GOTOXY(2, 3);
        PUTS("97/06/20 Fri 13:22");
        GOTOXY(2, 4);
        PUTS("Event:  11/SR     ");
        GOTOXY(2, 5);
        PUTS("Port:   COM2      ");
        GOTOXY(2, 6);
        PUTS("DTE:    115200    ");
        GOTOXY(2, 7);
        PUTS("Status: Idle      ");
        GOTOXY(2, 8);
        PUTS("Session:          ");
        GOTOXY(2, 9);
        PUTS("Protcol:          ");
        GOTOXY(2, 10);
        PUTS("Netmail:-         ");
        GOTOXY(2, 11);
        PUTS("MemF");

        /* Today at a Glance Window */

        ATTRIBUTES(colour_p->tday);
        GOTOXY(21, 3);
        PUTS("In M/B/F:     0/0/0");
        GOTOXY(21, 4);
        PUTS("Out:         0(0)/0");
        GOTOXY(21, 5);
        PUTS("Rx #/Vol.:      0/0");
        GOTOXY(21, 6);
        PUTS("Tx #/Vol.:      0/0");
        GOTOXY(21, 7);
        PUTS("Last:     2:204/145");
        GOTOXY(21, 8);
        PUTS("                   ");

        /* Pending Outbound Mail window */

        ATTRIBUTES(colour_p->pndg);
        GOTOXY(41, 3);
        PUTS("Address           Files Size Age  State");
        GOTOXY(41, 5);
        PUTS("2:206/216             0   0    0  N   -");
        GOTOXY(41, 6);
        PUTS("2:206/221.1           1  60K   0 H    -");
        GOTOXY(41, 7);
        PUTS("2:206/221.13          3  17K  10 H    -");
        GOTOXY(41, 8);
        PUTS("81:446/400            1 2.0K   0  N   -");

        /* Reverse video
         */

        ATTRIBUTES(colour_p->rev);
        GOTOXY(41, 4);
        PUTS("2:206/0               1 3.1K   0  N   -");

        /* Recent Activity window */

        ATTRIBUTES(colour_p->actvty);
        GOTOXY(2, 14);
        PUTS("    ");
        for (count = 15; count < 20; count ++) {
            GOTOXY(2, count);
            PUTS("                                                           ");
        }
        GOTOXY(2, 20);
        PUTS("+ 14:33:29 begin, BinkleyTerm Colour Config Ver. " VERSION "XE/5  ");
        GOTOXY(2, 21);
        PUTS(": 14:33:29 Starting Event 10                               ");
        GOTOXY(2, 22);
        PUTS(": 14:33:33 Entering COLOUR CONFIGURATION Mode              ");

        /* Transfer Status window */

        ATTRIBUTES(colour_p->trnsfr);
        GOTOXY(21, 10);
        PUTS("Event 11 (Tyst / S R ) is running.                         ");
        GOTOXY(76, 11);
        PUTS("    ");

        /* Pop-Up window */

        ATTRIBUTES(colour_p->popwin);
        GOTOXY(6, 11);
        PUTS("ڴ");
        GOTOXY(17, 11);
        PUTS("Ŀ");
        GOTOXY(6, 12);
        PUTS(" Poll:       ________________________________________               ");
        GOTOXY(6, 13);
        PUTS("                                                                    ");
        GOTOXY(6, 14);
        PUTS("");

        /* Modem activity window */

        ATTRIBUTES(colour_p->modemsent);
        GOTOXY(76, 14);
        PUTS("    ");
        for (count = 15; count < 21; count ++) {
            GOTOXY(62, count);
            PUTS("                  ");
        }
        GOTOXY(62, 21);
        PUTS("ATZ               ");

        ATTRIBUTES(colour_p->modemrecv);
        GOTOXY(62, 22);
        PUTS("OK                ");

        /* Border text */

        ATTRIBUTES(colour_p->brdrtext);
        GOTOXY(3, 2);
        PUTS("Current Settings");
        GOTOXY(22, 2);
        PUTS("Today at a Glance");
        GOTOXY(42, 2);
        PUTS("Pending Outbound Mail");
        GOTOXY(22, 9);
        PUTS("Status");
        GOTOXY(8, 11);
        PUTS("Poll Node");
        GOTOXY(3, 13);
        PUTS("Rec");
        GOTOXY(76, 13);
        PUTS("y");

        /* Window borders */

        ATTRIBUTES(colour_p->winborder);
        GOTOXY(1, 2);
        PUTS("ڴ");
        GOTOXY(19, 2);
        PUTS("´");
        GOTOXY(39, 2);
        PUTS("´");
        GOTOXY(63, 2);
        PUTS("Ŀ");

        for(count = 3; count < 12; count ++) {
            GOTOXY(1, count);
            PUTS("");
            if (count != 9) {
                GOTOXY(80, count);
                PUTS("");
            }
            if (count < 11 && count != 9) {
                GOTOXY(20, count);
                PUTS("");
            }
            if (count < 9) {
                GOTOXY(40, count);
                PUTS("");
            }
            if (count < 11) {
               GOTOXY(61, count + 12);
               PUTS("");
            }
            GOTOXY(1, count + 11);
            PUTS("");
            GOTOXY(80, count + 11);
            PUTS("");
        }
        GOTOXY(20, 9);
        PUTS("ô");
        GOTOXY(28, 9);
        PUTS("Ĵ");
        GOTOXY(1, 12);
        PUTS("");
        GOTOXY(76, 12);
        PUTS("ڴ");
        GOTOXY(77, 13);
        PUTS("Ŀ");

        GOTOXY(1, 23);
        PUTS("");

    } /* switch */
}

/*
 * colourconfiguration
 * The function that does the actual work
 */

void colourconfiguration(Binkcolour *colour_p)
{
    char *textareas[] = { "Border colour", "Current Settings window",
                          "Today at a Glance window", "Pending Outbound Mail window",
                          "Recent Activity window", "Transfer Status window",
                          "Reverse video colour", "Pop-Up window colour",
                          "Window border text", "Window border",
                          "Sent modem data", "Received modem data" };
    unsigned short int  currarea = 0, numareas;
    char                ch;
    unsigned int       *currcolour_p;
#ifdef __EMX__
    int                 normcursorstart, normcursorend;
#endif

    /* Select the number of colour areas available */

    switch (colour_p->xeflag) {
    case plain: numareas = TEXTAREAS;    break;
    case xr1:   numareas = XETEXTAREAS;  break;
    case xr5:   numareas = XE5TEXTAREAS; break;
    }

    /* Hide the cursor */

#ifdef __TURBOC__
    _setcursortype(_NOCURSOR);
#endif
#ifdef __EMX__
    v_getctype(&normcursorstart, &normcursorend);
    v_hidecursor();
#endif

    /* Black out the screen and draw it using the current colours */

    ATTRIBUTES(0);
    CLRSCR();
    paintscreen(colour_p);

    /* Write information at the bottom of the screen */

    ATTRIBUTES(7);
    GOTOXY(1, 25);
    currcolour_p = &(((unsigned int *) colour_p)[currarea]);

    PRINTF("Current work area: %s (#%03u=$%02X)", textareas[currarea],
            *currcolour_p, *currcolour_p);

    while (27 != (ch = getch())) { /* As long as we have not pressed ESCape */
        if (0 == ch)
            ch = getch();

        switch (ch) {
        case 72:    /* Up arrow (previous background colour) */
            *currcolour_p = (*currcolour_p + 0xF0) & 0xFF;
            paintscreen(colour_p);
            break;
        case 80:    /* Down arrow (next background colour) */
            *currcolour_p = (*currcolour_p + 0x10) & 0xFF;
            paintscreen(colour_p);
            break;
        case 75:    /* Left arrow (previous foreground colour) */
            *currcolour_p = (*currcolour_p & 0xF0) +
                            (((*currcolour_p & 0x0F) + 0x0F) & 0x0F);
            paintscreen(colour_p);
            break;
        case 77:    /* Right arrow (next foreground colour) */
            *currcolour_p = (*currcolour_p & 0xF0) +
                            (((*currcolour_p & 0x0F) + 0x01) & 0x0F);
            paintscreen(colour_p);
            break;
        case 81:    /* Page Down (next colour item) */
            currarea = (currarea + 1) % numareas;
            break;
        case 73:    /* Page Up (previous colour item) */
            currarea = (currarea + numareas - 1) % numareas;
            break;
        }

        currcolour_p = &(((unsigned int *) colour_p)[currarea]);

        ATTRIBUTES(7);
        GOTOXY(1, 25);
        PRINTF("Current work area: %s (#%03u=$%02X)                ",
                textareas[currarea], *currcolour_p, *currcolour_p);
    }

    /* Show the cursor again */

#ifdef __TURBOC__
    _setcursortype(_NORMALCURSOR);
#endif
#ifdef __EMX__
    v_ctype(normcursorstart, normcursorend);
#endif
}
